/**
 * Created by robin on 11/4/15.
 */

angular.module('luticateUtils')
    .directive('luPermissionEdit', ['dialogs', 'luticateDialogErrorHelper', 'luticateAuthPermissions',
        function(dialogs, luticateDialogErrorHelper, luticateAuthPermissions) {
            return {
                restrict: 'E',
                scope: {
                    luModel: '&'
                },
                templateUrl: "/luticate/lupermissionedit.html",
                link: function ($scope, element, attrs) {

                    $scope.permissions = [];
                    $scope.allPermissions = [];
                    $scope.tmpPermission = {
                        Name: "",
                        Value: true
                    };
                    var luModel = $scope.luModel();

                    $scope.editPermission = function(permission, value)
                    {
                        var promiseEditPermission = {
                            id: "promiseEditPermission_" + permission.Name,
                            loaderGroups: ['permission_' + permission.Name]
                        };
                        luModel.getEditPermissionPromise(permission.Name, value, promiseEditPermission)
                            .then(function(data)
                            {
                                permission.Value = value;
                            }, luticateDialogErrorHelper.errorDialog);
                    };

                    $scope.delPermission = function(permission)
                    {
                        var promiseDelPermission = {
                            id: "promiseDelPermission_" + permission.Name,
                            loaderGroups: ['permission_' + permission.Name]
                        };
                        luModel.getDelPermissionPromise(permission.Name, promiseDelPermission)
                            .then(function(data)
                            {
                                $scope.loadPermissions();
                            }, luticateDialogErrorHelper.errorDialog);
                    };

                    $scope.addPermission = function(permission)
                    {
                        var promiseAddPermission = {
                            id: "promiseAddPermission_" + permission.Name,
                            loaderGroups: ['permission_add']
                        };
                        luModel.getAddPermissionPromise(permission.Name, permission.Value, promiseAddPermission)
                            .then(function(data)
                            {
                                $scope.loadPermissions();
                            }, luticateDialogErrorHelper.errorDialog);
                    };

                    $scope.loadPermissions = function() {

                        var promiseLoadPermissions = {
                            id: "promiseLoadPermissions_",
                            groups: ['permissionList']
                        };
                        luModel.getGetAllPromise(null, null, promiseLoadPermissions)
                            .then(function (permissions) {
                                $scope.permissions = permissions.Data;
                            }, luticateDialogErrorHelper.errorDialog);
                    };

                    $scope.loadAllPermissions = function() {

                        var promiseLoadAllPermissions = {
                            id: "promiseLoadAllPermissions",
                            groups: ['permission_add']
                        };
                        luticateAuthPermissions.getAll(null, promiseLoadAllPermissions)
                            .then(function (permissions) {
                                $scope.allPermissions = permissions.Data;
                                $scope.tmpPermission.Name = $scope.allPermissions[0].Name;
                            }, luticateDialogErrorHelper.errorDialog);
                    };

                    $scope.loadPermissions();
                    $scope.loadAllPermissions();
                }
            };
        }]);

angular.module('luticateUtils').run(['$templateCache', function($templateCache)
{
    $templateCache.put('/luticate/lupermissionedit.html', '<div class="col-sm-12">' +
'        <div class="form-group col-sm-12"  lu-busy="permissionList">' +
'    <div class="col-sm-6" ng-repeat="permission in permissions" lu-busy="{group: \'permission_\' + permission.Name}">' +
'    <label class="col-sm-6 control-label">{{ permission.Name }}</label>' +
'<div class="col-sm-6">' +
'    <div class="btn-group">' +
'    <a class="btn btn-default dropdown-toggle btn-select" data-toggle="dropdown" href="">' +
'    {{ permission.Value ? \'Allow\' : \'Disallow\' }} <span class="caret"></span>' +
'    </a>' +
'    <ul class="dropdown-menu">' +
'    <li><a href="" ng-click="editPermission(permission, false)">Disallow</a></li>' +
'<li><a href="" ng-click="editPermission(permission, true)">Allow</a></li>' +
'</ul>' +
'</div>' +
'<div class="btn-group">' +
'    <button type="button" class="btn btn-default" ng-click="delPermission(permission)">' +
'    <span class="glyphicon glyphicon-remove" aria-hidden="true"></span>' +
'    </button>' +
'    </div>' +
'    </div>' +
'    </div>' +
'    </div>' +
'    <div class="clearfix"></div>' +
'    <div class="col-sm-12" lu-busy="permission_add">' +
'    <div class="btn-group">' +
'    <a class="btn btn-default dropdown-toggle btn-select" data-toggle="dropdown" href="">' +
'    {{ tmpPermission.Name }} <span class="caret"></span>' +
'    </a>' +
'    <ul class="dropdown-menu">' +
'    <li ng-repeat="permission in allPermissions">' +
'    <a href="" ng-click="tmpPermission.Name = permission.Name">{{ permission.Name}}</a>' +
'</li>' +
'</ul>' +
'</div>' +
'<div class="btn-group">' +
'    <a class="btn btn-default dropdown-toggle btn-select" data-toggle="dropdown" href="">' +
'    {{ tmpPermission.Value ? \'Allow\' : \'Disallow\' }} <span class="caret"></span>' +
'    </a>' +
'    <ul class="dropdown-menu">' +
'    <li><a href="" ng-click="tmpPermission.Value = false">Disallow</a></li>' +
'<li><a href="" ng-click="tmpPermission.Value = true">Allow</a></li>' +
'</ul>' +
'</div>' +
'<button type="button" class="btn btn-default" ng-click="addPermission(tmpPermission)">' +
'    <span class="glyphicon glyphicon-plus" aria-hidden="true"></span> Add' +
'    </button>' +
'    </div>' +
'    </div>');
}]);